<template>
  <div v-if="slicedPromotion.length > 0" class="hot-promo px-2 sm:px-0">
    <div :class="isDisabledActivePromotion ? 'h-4 mb-2' : 'h-[52px]'">
      <div class="flex items-center whitespace-nowrap gap-2 primary">
        <div
          :class="[
            'font-bold uppercase',
            isDisabledActivePromotion ? 'text-sm' : 'text-2xl',
          ]"
        >
          {{ $t("Hot Promo") }}
        </div>
        <el-divider
          :class="['primary', { 'custom-border-1': isDisabledActivePromotion }]"
        />
      </div>
    </div>
    <div
      v-if="activePromotion"
      :class="[
        'flex',
        isDisabledActivePromotion ? 'h-[124px]' : 'h-[180px] gap-4',
      ]"
    >
      <div
        v-if="!isDisabledActivePromotion"
        class="w-[238px] rounded-lg promotion-container p-6"
      >
        <div class="flex-auto w-[190px]">
          <div class="line-clamp-2 title">{{ activePromotion?.Title }}</div>
          <div class="line-clamp-2 remark">{{ activePromotion?.Remark }}</div>
        </div>
        <div
          v-if="!authenticated"
          class="grid justify-between gap-2 grid-cols-2"
        >
          <nuxt-link :to="`/promotion/${activePromotion?.Id}`">
            <el-button
              class="hot-promo-btn flex-auto text-sm border-none w-full"
              >{{ $t("Info") }}
            </el-button>
          </nuxt-link>
          <nuxt-link to="/login">
            <el-button class="hot-promo-btn apply">
              {{ $t("apply") }}
            </el-button>
          </nuxt-link>
        </div>
        <div
          v-else
          class="grid justify-between gap-2"
          :class="
            !(
              activePromotion?.PromotionTypeId === 10 ||
              buttonApplyPromotionEnabled(activePromotion)
            )
              ? 'grid-cols-1'
              : 'grid-cols-2'
          "
        >
          <nuxt-link :to="`/promotion/${activePromotion?.Id}`">
            <el-button
              class="hot-promo-btn flex-auto text-sm border-none w-full"
              >{{ $t("Info") }}
            </el-button>
          </nuxt-link>
          <el-button
            v-if="activePromotion?.PromotionTypeId === 10"
            class="hot-promo-apply w-full text-sm border-none"
            @click="onClickSpinNow"
          >
            {{ $t("Spin Now") }}
          </el-button>
          <el-button
            v-else-if="buttonApplyPromotionEnabled(activePromotion)"
            :loading="isProcessing"
            :disabled="isProcessing"
            class="hot-promo-apply text-sm border-none w-full"
            @click="onApplyPromotion(activePromotion)"
          >
            {{ $t("apply") }}
          </el-button>
        </div>
      </div>
      <swiper
        :key="rerender"
        :slides-per-view="'auto'"
        :space-between="initSpaceSwiper"
        :slide-to-clicked-slide="true"
        :modules="modules"
        :loop="true"
        :autoplay="{
          delay: 4800,
          disableOnInteraction: false,
        }"
        class="remove-scroll-bar flex-auto !overflow-hidden"
        @slide-change-transition-end="(targets: any) => onPromotionSelected(targets)"
      >
        <swiper-slide
          v-for="(promotion, index) in slicedPromotion"
          :key="index"
          :class="[
            'rounded-lg  slide-item',
            isDisabledActivePromotion
              ? '!h-[124px] !w-[280px]'
              : '!h-[180px] !w-[405px]',
          ]"
          :promotion="JSON.stringify(promotion)"
          @click="
            () =>
              isDisabledActivePromotion
                ? onMoreInformation(activePromotion)
                : () => {}
          "
        >
          <div
            class="bg-black absolute w-full h-full rounded-lg opacity-active"
            style="z-index: 1 !important"
          ></div>
          <div class="relative w-full h-full rounded-lg">
            <img
              v-lazy="promotion.ImagePathForDisplay"
              class="w-full h-full object-cover rounded-lg"
            />
          </div>
        </swiper-slide>
      </swiper>
    </div>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent } from "vue";
import { Autoplay } from "swiper";
import { sortBy } from "lodash-es";
import { store } from "@/store";
import {
  IThemePropertiesFromApi,
  ThemePropertiesFromApiDto,
} from "@/models/companyThemePropertiesRespone";
import themePropertiesHelper from "@/utils/themePropertyHelper";
import { IPromotion } from "~~/models/promotion/promotion";

export default defineComponent({
  name: "LobbyGamePromotion",
  props: {
    isUseText: {
      type: Boolean,
      default: true,
    },
    isAnimateThemeColor: {
      type: Boolean,
      default: false,
    },
  },
  setup() {
    const {
      promotions,
      onApplyPromotion,
      isProcessing,
      onMoreInformation,
      isDialogVisible = false,
      promotionModel,
      buttonApplyPromotionEnabled,
      onClickSpinNow,
    } = usePromotion();
    const authenticated = computed(() => store.state.auth);
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const themeTitle = computed(
      (): IThemePropertiesFromApi =>
        themePropertiesHelper.getSingleThemeProperty(
          themeProperties.value,
          "index_blog_2"
        )
    );
    const seeAllLink = computed(
      (): IThemePropertiesFromApi =>
        themePropertiesHelper.getSingleThemeProperty(
          themeProperties.value,
          "index_blog_2_see_all"
        )
    );
    const themeContent = computed((): Array<ThemePropertiesFromApiDto> => {
      const tem = themePropertiesHelper.getMultipleThemesProperties(
        themeProperties.value,
        "index_blog_content_2_"
      );
      return tem.map((item) => new ThemePropertiesFromApiDto(item));
    });
    const themeImages = computed((): Array<ThemePropertiesFromApiDto> => {
      let tem = themePropertiesHelper.getMultipleThemesProperties(
        themeProperties.value,
        "index_blog_2_"
      );
      tem = tem.filter((item) => !item.HtmlId.includes("see_all"));
      return tem.map((item) => new ThemePropertiesFromApiDto(item));
    });
    const slicedPromotion = computed(() => {
      const tinyPromotion = promotions.value.slice(0, 10);
      const renders =
        tinyPromotion.length < 6
          ? tinyPromotion.concat(tinyPromotion)
          : tinyPromotion;
      return renders;
    });
    const promoSelected = ref<IPromotion>(slicedPromotion.value[0]);
    const windowWidth = ref(window.innerWidth);
    window.addEventListener(
      "resize",
      () => (windowWidth.value = window.innerWidth)
    );
    const isDisabledActivePromotion = computed(() => windowWidth.value < 640);
    const onPromotionSelected = (targets: any) => {
      const selected = targets.slides.filter((slide: any) =>
        slide.classList.contains("swiper-slide-active")
      )[0];
      promoSelected.value = JSON.parse(selected.getAttribute("promotion"));
    };
    const activePromotion = computed(
      () => promoSelected.value ?? slicedPromotion.value[0]
    );
    const initSpaceSwiper = computed(() =>
      isDisabledActivePromotion.value ? 8 : 16
    );
    const rerender = computed(() => slicedPromotion.value.length);
    return {
      themeTitle,
      themeImages,
      themeContent,
      authenticated,
      seeAllLink,
      modules: [Autoplay],
      promotions,
      sortBy,
      slicedPromotion,
      onPromotionSelected,
      activePromotion,
      onApplyPromotion,
      isProcessing,
      windowWidth,
      isDisabledActivePromotion,
      onMoreInformation,
      isDialogVisible,
      promotionModel,
      initSpaceSwiper,
      rerender,
      buttonApplyPromotionEnabled,
      onClickSpinNow,
    };
  },
});
</script>
<style lang="scss" scoped>
:deep(.el-button.hot-promo-btn > span) {
  z-index: 1;
}
.primary {
  color: var(--primary);
  &.custom-border-1 {
    border-top: solid 1px var(--primary) !important;
  }
}
.el-divider--horizontal {
  border-top: solid 2px var(--primary);
  margin: 0 !important;
}
.remove-scroll-bar :deep(.swiper-scrollbar) {
  opacity: 0;
}
.promotion-container {
  display: flex;
  flex-direction: column;
  background: var(--background5);
  .line-clamp-2 {
    overflow: hidden;
    display: -webkit-box;
    -webkit-box-orient: vertical;
    -webkit-line-clamp: 2;
    word-break: break-word;
  }
  .title {
    font-size: 16px;
    color: var(--primary);
    text-transform: uppercase;
  }
  .remark {
    font-size: 14px;
    color: var(--text5);
  }
}
.hot-promo-btn {
  &.info {
    background: var(--secondary);
  }
  &.apply {
    background: var(--primary);
  }

  @apply flex-auto text-sm border-none w-full relative;
  color: var(--textBtn, #fff);
  border-color: transparent;

  &:before {
    content: "";
    background: rgba(23, 23, 23, 0.3);
    position: absolute;
    transition: opacity 0.3s ease;
    z-index: 1;
    width: 100%;
    height: 100%;
    border-radius: 4px;
    opacity: 0;
  }
  &:hover {
    &:before {
      opacity: 1;
    }
  }
}
.hot-promo {
  .el-button + .el-button {
    margin-left: 0px;
  }
}
:not(.swiper-slide-active) {
  .opacity-active {
    opacity: 0.5;
  }
}
.swiper-slide-active {
  .opacity-active {
    opacity: 0;
  }
}
</style>
